Attribute VB_Name = "modConnectToGlobe"
Option Explicit
     
     '//////////////////////////////////////////////   CURRENT VERSION  ///////////////////////////////////////////////////////////////
     '******************************************************************************
     Public Const gVersion As String = "V.2010.04.06"
     '******************************************************************************
    Private Const cDEBUG_MODE = True
    ' Private Const cDEBUG_MODE = False
     '******************************************************************************
     '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     
Public gConnSDK As CSSDKConnect.SDKConnection
Public hApp As Object   'Holds globe application object to connect with

Private mySDKConnect As CSSDKConnect.SDKConnect
Private ConnError As CSSDKConnect.SDKConnectionErrors



'/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Public Sub Connect_Via_Dispatcher(hApp As Object)
     Dim sConnect As String
     Dim bMain As Boolean
     
     If gConnSDK Is Nothing Then
          Set mySDKConnect = New CSSDKConnect.SDKConnect
          
          On Error GoTo ErrHandle
          '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
          '   ******************** FOR DEBUGGING ONLY ********************************
          'Will only set to debug mode if
          '         If DebugMode is turned on in the Public Constant cDEBUG_MODE = TRUE
          '         AND it is running from OTHER than the bin directory (i.e., from the development environment)
          'This is because cannot create the SalesOrderLine within the same sales order if debug mode is turned on in compiled version (It would be locked)
          'NOTE:  When debugging the Add Sales Order Line, it will be LOCKED unless ran from CSExactCA.dll with debug mode turned OFF.
          '   *****************************************************************************
          If Right(UCase(Trim(VB.App.Path)), 3) <> "BIN" Then
               'MsgBox "x DEBUG MODE" ':  " & Right(UCase(Trim(VB.App.Path)), 3)
               mySDKConnect.DebugMode = cDEBUG_MODE
          End If
          '   ******************** FOR DEBUGGING ONLY ********************************
          '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
               
          ConnError = mySDKConnect.ConnectViaDispatcher(hApp, gConnSDK)

          If ConnError <> SDKNoError And ConnError <> ConnErrAlreadyConnected Then
               Call DisplayConnectionError
          End If
     End If
Exit Sub
ErrHandle:
     MsgBox "Error in modConnectToGlobe - Connect_Via_Dispatcher " & vbCrLf & Err.Number & ":  " & Err.Description, vbCritical, "ERROR in VB"
End Sub

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////     SDK ERROR HANDLERS      ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Private Sub DisplayConnectionError()
On Error GoTo ErrHandle
'//////////////////////////////////////////////////
     Select Case ConnError
          Case ConnErrAlreadyConnected
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "You are already connected.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidServer
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Wrong servername.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidDatabase
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Wrong databasename.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidLicense
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "No valid license installed.", vbOKOnly, "Error in SDK"
          Case ConnErrDatabaseVersion
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Database version not correct.", vbOKOnly, "Error in SDK"
          Case ConnErrUserAbort
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User abort.", vbOKOnly, "Error in SDK"
          Case ConnErrUserBlocked
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User blocked.", vbOKOnly, "Error in SDK"
          Case ConnErrSDKVersion
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "SDK version not correct.", vbOKOnly, "Error in SDK"
          Case ConnErrLicenseExpired
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Your license has expired.", vbOKOnly, "Error in SDK"
          Case ConnErrUserNotFound
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User not found.", vbOKOnly, "Error in SDK"
          Case Else
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "An unexpected error occurred. No connection could be made.", vbOKOnly, "Error in SDK"
     End Select
'//////////////////////////////////////////////////
Exit Sub
ErrHandle:
     MsgBox "Error in modConnectToGlobe - DisplayConnectionError" & vbCrLf & Err.Number & ":  " & Err.Description, vbCritical, "ERROR in VB"
End Sub

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


Public Sub Disconnect_Globe()
On Error Resume Next
     If Not gConnSDK Is Nothing Then
          Call mySDKConnect.Disconnect(gConnSDK)
          Set mySDKConnect = Nothing
          Set gConnSDK = Nothing
     End If
Exit Sub
ErrorHandler:
     MsgBox Err.Description
End Sub

'/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Public Sub SDKErrorHandler(ByRef oSDKErrortype As CSSDKConnect.SDKErrorType, ByVal Validations As Variant, ByVal sTitle As String)
     Dim sError As String
     Dim lCount As Long
          
     sError = oSDKErrortype.ErrDescr & vbNewLine
     If oSDKErrortype.ErrNr = SDKErrValidationFailed Then 'the Validations is only filled for this errortype
          For lCount = LBound(Validations) To UBound(Validations)
               sError = sError & CStr(Validations(lCount)) & vbNewLine
          Next lCount
     End If
     MsgBox sError, vbOKOnly, sTitle
End Sub

