Attribute VB_Name = "modGlobal"
Option Explicit


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////////////////  CONSTANT DECLARATIONS      ///////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Private Const cModuleName As String = "modGlobal"

'PUBLIC CONSTANTS for Module Names
'Used in IF statements for code only running in particular modules - Avoids typo's in string comparisons
Public Const c_iInvoice As String = "iInvoice"
Public Const c_iPurchaseOrder As String = "iPurchaseOrder"
Public Const c_iSalesOrder As String = "iSalesOrder"
Public Const c_iQuotation As String = "iQuotation"
Public Const c_modGlobal = "modGlobal"
Public Const c_modConnectToGlobe = "modConnectToGlobe"
Public Const c_modConnectToADO = "modConnectToGlobe"


Public oInvoice As CSSDKInvoice.SDKInvoice


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////   API DECLARATIONS AND CONSTANTS     ////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Const HWND_TOPMOST = -1
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2

Public Declare Function GetUsername Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////   PUBLIC VARIABLES     //////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'*************************** FORM VARIABLES  ************************************************
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'Declare Variables

Public fOrderDetails As frmOrderDetails
Public fExtraFields As frmExtraFields

Public gOrdernr As String
Public gCustomerNo As String
Public gDeliverTo


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////   PRIVATE VARIABLES     ///////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Private Sub XXXXX()
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     On Error GoTo ErrHandle
     '/////////////////////////////////////////////////////////
     '/////////////////////////////////////////////////////////
     Exit Sub
ErrHandle:
     MsgBox "ERROR IN " & cModuleName & " - XXXXX :  " & Err.Number & " - " & Err.Description, vbOKOnly, "ERROR"
End Sub
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////   PROCEDURES     //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Sub SelectText(frm As Form)
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     On Error Resume Next
     '//////////////////////////////////////////////////////
     'This procedure selects all of the text in the textbox
     ' Call from the GotFocus of any textbox on any form using
     '            SelectText(Me)
     
     'Selects everything in the current control
     'Verify Textbox
     If TypeName(frm.ActiveControl) <> "TextBox" Then
          Exit Sub
     End If
     
     'Select all text
     With frm.ActiveControl
          .SelStart = 0
          .SelLength = Len(.Text)
     End With
     
End Sub

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Function GetFileNameFromPath(Path As String) As String
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     On Error Resume Next
     '//////////////////////////////////////////////////////
     Dim LastPos As Integer
     Dim Pos As Integer
     
     Pos = 0
     Do
          LastPos = Pos
          Pos = InStr(LastPos + 1, Path, "\")
     Loop Until Pos = 0
     GetFileNameFromPath = Mid(Path, LastPos + 1, Len(Path))
End Function


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Function GetCompanyNameAndState(HEADER_TABLENAME As String) As String
     On Error GoTo ErrHandle
     '//////////////////////////////////////////////////////
     'When the Deliver to changes on a sales order, want to change the Description to
     ' The first 17 char of the Customer name & " " & 2 char StateCode

     Dim SQL As String
     Dim DBQueryLOC  As CSSDKFuncDBQuery.SDKDBQuery  '
     Dim qrLoc As CSSDKFuncDBQuery.SDKQuery
     Dim locResponse As Integer 'for messageboxes

     ' __________________ CONNECT SDK ___________________
     Call Connect_Via_Dispatcher(hApp)
     ' _______________________________________________________
     'Create Query Object
     'Create instance of DB Query
     Set DBQueryLOC = New CSSDKFuncDBQuery.SDKDBQuery

     'Initialize DB Query
     Call DBQueryLOC.InitializeSDKConnection(gConnSDK)

     ' Set Return value to ""
     GetCompanyNameAndState = ""


      '///////////////////////////////
      'GET Company Name
      '///////////////////////////////
     'Create SQL Stmt for PURCHASE ORDER to find Order Number from linked Sales Order

     SQL = " SELECT CmpNameAndState = left(c.cmp_name,17) + '-' + left(isnull(A.StateCode,''),2) " & vbCrLf
     SQL = SQL & " FROM cicmpy C  with (nolock) " & vbCrLf
     SQL = SQL & " INNER JOIN Addresses A with (nolock) " & vbCrLf
     SQL = SQL & " ON C.cmp_wwn = A.Account  " & vbCrLf
     SQL = SQL & " WHERE C.debnr = " & gDeliverTo
     SQL = SQL & " AND A.main = 1 " & vbCrLf
     SQL = SQL & " AND A.type = 'DEL' " & vbCrLf

   'EXECUTE THE QUERY
     Set qrLoc = DBQueryLOC.ExecuteSQL(SQL)
                                                                                'If error then quit
                                                                                If DBQueryLOC.ErrorSDKDBQuery <> "" Then
                                                                                     MsgBox "Could not retrieve CmpNameAndState :  " & DBQueryLOC.ErrorSDKDBQuery
                                                                                     
                                                                                     ' _______________  DISCONNECT SDK   __________________
                                                                                     Call Disconnect_Globe
                                                                                     ' _______________________________________________________

                                                                                     Exit Function
                                                                                End If

     'FETCH THE SALES ORDER NUMBER
     qrLoc.FetchFirst

     'VERIFY Customer found
     If qrLoc.EOF Then
          'Do not give a warning or will cause issues when user types in value
          Exit Function
     End If

     'SET THE SALES ORDER NUMBER VARIABLE
     GetCompanyNameAndState = Trim(qrLoc.vVar("CmpNameAndState") & "")     'PurchaseOrderNr in PO returns related SO number

     Set qrLoc = Nothing
     Set DBQueryLOC = Nothing

     ' _______________  DISCONNECT SDK   __________________
     Call Disconnect_Globe
     ' _______________________________________________________

'////////////////////////////////////////////////
Exit Function
ErrHandle:
     MsgBox "ERROR IN " & cModuleName & " - GetCompanyNameAndState :  " & Err.Number & " - " & Err.Description, vbOKOnly, "ERROR"
End Function




'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Function GetCurrentGlobeResourceID() As Variant
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     On Error GoTo ErrHandle
     '/////////////////////////////////////////////////////////
     Dim NTUser As String
     NTUser = GetNTUserID
     
     'Look up in Humres Table
     
          'When the Deliver to changes on a sales order, want to change the Description to
     ' The first 17 char of the Customer name & " " & 2 char StateCode

     Dim SQL As String
     Dim DBQueryLOC  As CSSDKFuncDBQuery.SDKDBQuery  '
     Dim qrLoc As CSSDKFuncDBQuery.SDKQuery
     Dim locResponse As Integer 'for messageboxes

     ' __________________ CONNECT SDK ___________________
     Call Connect_Via_Dispatcher(hApp)
     ' _______________________________________________________
     'Create Query Object
     'Create instance of DB Query
     Set DBQueryLOC = New CSSDKFuncDBQuery.SDKDBQuery

     'Initialize DB Query
     Call DBQueryLOC.InitializeSDKConnection(gConnSDK)

     ' Set Return value to ""
     GetCurrentGlobeResourceID = ""


      '///////////////////////////////
      'GET Company Name
      '///////////////////////////////
     'Create SQL Stmt for PURCHASE ORDER to find Order Number from linked Sales Order

     SQL = " SELECT res_id"
     SQL = SQL & " FROM humres H with (nolock) " & vbCrLf
     SQL = SQL & " WHERE ltrim(rtrim(h.usr_id))= '" & NTUser & "'"

   'EXECUTE THE QUERY
     Set qrLoc = DBQueryLOC.ExecuteSQL(SQL)
                                                                                'If error then quit
                                                                                If DBQueryLOC.ErrorSDKDBQuery <> "" Then
                                                                                     MsgBox "Could not retrieve UserID :  " & DBQueryLOC.ErrorSDKDBQuery
                                                                                     Err.Raise Err.Number, , Err.Description
                                                                                     
                                                                                     ' _______________  DISCONNECT SDK   __________________
                                                                                     Call Disconnect_Globe
                                                                                     ' _______________________________________________________

                                                                                     Exit Function
                                                                                End If

     'FETCH THE SALES ORDER NUMBER
     qrLoc.FetchFirst


     'SET THE SALES ORDER NUMBER VARIABLE
     GetCurrentGlobeResourceID = Trim(qrLoc.vVar("res_id") & "")     'PurchaseOrderNr in PO returns related SO number

     Set qrLoc = Nothing
     Set DBQueryLOC = Nothing

     ' _______________  DISCONNECT SDK   __________________
     Call Disconnect_Globe
     ' _______________________________________________________

     
     '/////////////////////////////////////////////////////////
     Exit Function
ErrHandle:
     MsgBox "ERROR IN " & cModuleName & " - GetCurrentGlobeResourceID :  " & Err.Number & " - " & Err.Description, vbOKOnly, "ERROR"
End Function
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

'////////////////        GET NTUSERID           //////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Function GetNTUserID()
     
     'Returns NT UserID
     '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
     On Error GoTo ErrHandle
     '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
     Dim str As String
     Dim API_Return As Integer
     Dim length As Long
     
     'Create string of nulls
     str = String(255, 0)
     
     'Call API
     API_Return = GetUsername(str, Len(str))
     
     'Returns 0 if failure
     If API_Return = 0 Then
          'failure
          GetNTUserID = ""
          Exit Function
     End If
     
     'str will have NTUserID followed by string of nulls
     'Find the first null characters in the string to determine the length of the userid
     length = InStr(1, str, Chr(0)) - 1
     
     str = Left(str, length)
     
     'RETURN
     GetNTUserID = Trim(str)
     '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
     
     '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
     Exit Function
ErrHandle:
     GetNTUserID = ""
'     MsgBox "Error Number:  " & Err.Number & vbCrLf & Err.Description, _
'     vbCritical, "Error in ' modUserName - GetNTUserID ' procedure "
End Function




'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Public Function ConvertToDate(YYYYMMDD As Variant) As String
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     On Error GoTo ErrHandle
     '/////////////////////////////////////////////////////////
     Dim s As String
     'Takes in YYYYMMDD Returns MM/DD/YYYY
     s = Mid(YYYYMMDD, 5, 2) & "/" & Right(YYYYMMDD, 2) & "/" & Left(YYYYMMDD, 4)
     If Not IsDate(s) Then
          ConvertToDate = ""
     Else
          ConvertToDate = s
     End If
     
     '/////////////////////////////////////////////////////////
     Exit Function
ErrHandle:
     MsgBox "ERROR IN " & cModuleName & " - ConvertToDate :  " & Err.Number & " - " & Err.Description, vbOKOnly, "ERROR"
End Function
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



