Attribute VB_Name = "modConnectToGlobe"
Option Explicit
Public Const cModuleName = "modConnectToGlobe"
     '//////////////////////////////////////////////   CURRENT VERSION  ///////////////////////////////////////////////////////////////
     
Private mySDKConnect As CSSDKConnect.SDKConnect
Public gConnSDK As CSSDKConnect.SDKConnection
Private ConnError As CSSDKConnect.SDKConnectionErrors
Public hApp As Object

'/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Public Function Connect_Via_Globe(hApp As Variant) As Boolean
     On Error GoTo ErrHandle
     '///////////////////////////////////////////////////
    Connect_Via_Globe = False
    
    If gConnSDK Is Nothing Then
        Set mySDKConnect = New CSSDKConnect.SDKConnect
        Dim sConnect As String
        Dim bMain As Boolean
                
        ConnError = mySDKConnect.ConnectViaGlobe(hApp, gConnSDK)
    
        If ConnError <> SDKNoError And ConnError <> ConnErrAlreadyConnected Then
            Call DisplayConnectionError
            Exit Function
        End If
        
    End If
    Connect_Via_Globe = True
     '//////////////////////////////////////////////////////
     Exit Function
ErrHandle:
    MsgBox "Error in Connect_Via_Globe:  " & Err.Number & " " & Err.Description, vbOKOnly, "ERROR Connecting to Globe"
    Connect_Via_Globe = False
End Function

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


























Public Sub Connect_Via_Dispatcher(hApp As Object)
     On Error GoTo ErrHandle
     '///////////////////////////////////////////////////


     If gConnSDK Is Nothing Then
          Set mySDKConnect = New CSSDKConnect.SDKConnect
          Dim sConnect As String
          Dim bMain As Boolean
          
          
          ConnError = mySDKConnect.ConnectViaDispatcher(hApp, gConnSDK)

          If ConnError <> SDKNoError And ConnError <> ConnErrAlreadyConnected Then
               Call DisplayConnectionError
          End If
     End If
     '//////////////////////////////////////////////////////
     Exit Sub
ErrHandle:
     MsgBox Err.Description
End Sub


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////     SDK ERROR HANDLERS      ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Private Sub DisplayConnectionError()
On Error GoTo ErrHandle
'//////////////////////////////////////////////////
     Select Case ConnError
          Case ConnErrAlreadyConnected
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "You are already connected.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidServer
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Wrong servername.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidDatabase
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Wrong databasename.", vbOKOnly, "Error in SDK"
          Case ConnErrInvalidLicense
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "No valid license installed.", vbOKOnly, "Error in SDK"
          Case ConnErrDatabaseVersion
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Database version not correct.", vbOKOnly, "Error in SDK"
          Case ConnErrUserAbort
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User abort.", vbOKOnly, "Error in SDK"
          Case ConnErrUserBlocked
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User blocked.", vbOKOnly, "Error in SDK"
          Case ConnErrSDKVersion
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "SDK version not correct.", vbOKOnly, "Error in SDK"
          Case ConnErrLicenseExpired
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "Your license has expired.", vbOKOnly, "Error in SDK"
          Case ConnErrUserNotFound
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "User not found.", vbOKOnly, "Error in SDK"
          Case Else
               MsgBox "SDK Error in mod ConnectToGlobe - DisplayConnectionError - " & "An unexpected error occurred. No connection could be made.", vbOKOnly, "Error in SDK"
     End Select
     '//////////////////////////////////////////////////////
     Exit Sub
ErrHandle:
     MsgBox "Error in modConnectToGlobe - DisplayConnectionError" & vbCrLf & Err.Number & ":  " & Err.Description, vbCritical, "ERROR in VB"
End Sub

'//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


Public Sub Disconnect_Globe()
On Error Resume Next
          If Not gConnSDK Is Nothing Then
               Call mySDKConnect.Disconnect(gConnSDK)
               Set mySDKConnect = Nothing
               Set gConnSDK = Nothing
          End If
     '//////////////////////////////////////////////////////
     Exit Sub
ErrHandle:
     'MsgBox Err.Description
End Sub

'/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Public Sub SDKErrorHandling(ByRef oSDKErrortype As CSSDKConnect.SDKErrorType, ByVal Validations As Variant, ByVal sTitle As String)
     Dim sError As String
     Dim lCount As Long
          
     sError = oSDKErrortype.ErrDescr & vbNewLine
     If oSDKErrortype.ErrNr = SDKErrValidationFailed Then 'the Validations is only filled for this errortype
          For lCount = LBound(Validations) To UBound(Validations)
               sError = sError & CStr(Validations(lCount)) & vbNewLine
          Next lCount
     End If
     MsgBox sError, vbOKOnly, sTitle
End Sub

